Summary: Tool for finding and fixing problems in MP3 files; includes a tagger
%define version 0.99.05.033
License: http://www.gnu.org/licenses/gpl-2.0.html
Group: Applications/Multimedia
Name: MP3Diags
#Prefix: /usr
#Provides: MP3Diags
Release: 1
Source: MP3Diags-%{version}.tar.gz
URL: http://mp3diags
Version: %{version}
BuildRoot: %{_tmppath}/%{name}-%{version}-build

Packager: Ciobi

#BuildRequires: libqt4-devel
#BuildRequires: boost-devel
# ??? ttt0

%if 0%{?suse_version} > 0000
Requires: libqt4-x11
BuildRequires: zlib-devel boost-devel libqt4-devel
BuildRequires: update-desktop-files
%endif

%if 0%{?fedora} || 0%{?fedora_version}
Requires: qt-x11
#BuildRequires: qt-devel qt-config
BuildRequires: qt-devel zlib-devel boost-devel gcc-c++
%endif

# this breaks the build for mandriva 2009.1: parseExpressionBoolean returns -1
%if 0%{?mandriva_version} >= 2009
#%if 0%{?mdkversion} >= 200900
BuildRequires:  kdelibs4-devel
#BuildRequires:  libboost1.37.0-devel
BuildRequires:  libboost-devel
BuildRequires:  zlib-devel
Requires:       qt4-common
%endif
# related but probably something else: https://bugzilla.novell.com/show_bug.cgi?id=459337  or  https://bugzilla.redhat.com/show_bug.cgi?id=456103



%description
Finds problems in MP3 files and helps the user to fix many of them. Looks at both the audio part (VBR info, quality, normalization) and the tags containing track information (ID3.)

Has a tag editor, which can download album information (including cover art) from MusicBrainz and Discogs, as well as paste data from the clipboard. Track information can also be extracted from a file's name.

Another component is the file renamer, which can rename files based on the fields in their ID3V2 tag (artist, track number, album, genre, ...)



%prep
%setup -q



%build

./AdjustMt.sh


#%if 0%{?mandriva_version} > 2006
#export PATH=/usr/lib/qt4/bin:$PATH
#export QTDIR=%{_prefix}/lib/qt4/
#%endif

%if 0%{?suse_version}
qmake
%endif

%if 0%{?mandriva_version} >= 2009
#export PATH=/usr/lib/qt4/bin:$PATH
#export QTDIR=%{_prefix}/lib/qt4/
#ls /usr/lib/qt4/bin
#/usr/lib/qt4/bin/qmake
qmake
%endif

%if 0%{?fedora} || 0%{?fedora_version}
qmake-qt4
%endif

make
strip $RPM_BUILD_DIR/MP3Diags-%{version}/bin/MP3Diags

%install
# ttt1 perhaps look at http://doc.trolltech.com/4.3/qmake-variable-reference.html#installs and use INSTALLS += ...
echo mkdir $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp $RPM_BUILD_DIR/MP3Diags-%{version}/bin/MP3Diags $RPM_BUILD_ROOT%{_bindir}
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags.desktop $RPM_BUILD_ROOT%{_datadir}/applications
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/MP3Diags.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/22x22/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags22.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/22x22/apps/MP3Diags.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags24.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/apps/MP3Diags.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/MP3Diags.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/36x36/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags36.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/36x36/apps/MP3Diags.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/40x40/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags40.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/40x40/apps/MP3Diags.png
mkdir -p $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps
cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags48.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/MP3Diags.png


#mkdir -p $RPM_BUILD_ROOT%{_bindir}
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/bin/MP3Diags $RPM_BUILD_ROOT%{_bindir}

#mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags.desktop $RPM_BUILD_ROOT%{_datadir}/applications

#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags16.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/16x16/apps/MP3Diags.png
#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/22x22/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags22.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/22x22/apps/MP3Diags.png
#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags24.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/24x24/apps/MP3Diags.png
#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags32.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/32x32/apps/MP3Diags.png
#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/36x36/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags36.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/36x36/apps/MP3Diags.png
#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/40x40/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags40.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/40x40/apps/MP3Diags.png
#%dir $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps
#cp $RPM_BUILD_DIR/MP3Diags-%{version}/desktop/MP3Diags48.png $RPM_BUILD_ROOT%{_datadir}/icons/hicolor/48x48/apps/MP3Diags.png



%if 0%{?suse_version} > 0000
%suse_update_desktop_file -n MP3Diags
#echo ================ SUSE ================ SUSE ================
%endif
#error with suse_update_desktop_file -in MP3Diags , perhaps try suse_update_desktop_file -n -i MP3Diags


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root)
%dir %{_datadir}/icons/hicolor
%dir %{_datadir}/icons/hicolor/16x16
%dir %{_datadir}/icons/hicolor/16x16/apps
%dir %{_datadir}/icons/hicolor/22x22
%dir %{_datadir}/icons/hicolor/22x22/apps
%dir %{_datadir}/icons/hicolor/24x24
%dir %{_datadir}/icons/hicolor/24x24/apps
%dir %{_datadir}/icons/hicolor/32x32
%dir %{_datadir}/icons/hicolor/32x32/apps
%dir %{_datadir}/icons/hicolor/36x36
%dir %{_datadir}/icons/hicolor/36x36/apps
%dir %{_datadir}/icons/hicolor/40x40
%dir %{_datadir}/icons/hicolor/40x40/apps
%dir %{_datadir}/icons/hicolor/48x48
%dir %{_datadir}/icons/hicolor/48x48/apps
%{_bindir}/MP3Diags
%{_datadir}/applications/MP3Diags.desktop
%{_datadir}/icons/hicolor/16x16/apps/MP3Diags.png
%{_datadir}/icons/hicolor/22x22/apps/MP3Diags.png
%{_datadir}/icons/hicolor/24x24/apps/MP3Diags.png
%{_datadir}/icons/hicolor/32x32/apps/MP3Diags.png
%{_datadir}/icons/hicolor/36x36/apps/MP3Diags.png
%{_datadir}/icons/hicolor/40x40/apps/MP3Diags.png
%{_datadir}/icons/hicolor/48x48/apps/MP3Diags.png

#?datadir (=/usr/share)
#/usr/share/applications



%changelog
* Wed Sep 02 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.05.033
- fixed crash in Windows when checking a whole drive
- fixed crash when saving data from the tag editor
- improved trace speed on Windows
- fixed potential crash at startup
- fixed crash when changing a file that is being used by other program
- more details and better formatting in assert messages and trace files
- MPEG2 Layer3 streams no longer show Support note
- improved temporary file generation, which can result in faster transforms
- F1 help now works for the first session dialog
- smaller TABs in the "Tag details" area make "Other info" more readable
- better HTML paragraph formatting

* Sun Aug 23 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.05.032
- restructured crash detector
- fixed Windows issue with rectangles being shown instead of letters
- Lyrics partial support
- warning that may corrupt data
- note about how to change selected files
- HTML clean up

* Wed Aug 19 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.05.031
- crash detection
- fixed small memory leak in config dialog
- fixed small memory leak in the tag editor
- content is shown for GEOB frames
- .ID3 files are now loaded in addition to .MP3
- made the counter shown when applying transforms increment on new file(until now it was incremented for each transform)
- "Various artists" no longer set as "artist" when downloading track info from MusicBrainz
- fixed "current cell" in the tag editor (until now, when dragging the mouse to select several cells, the current cell was wrong, leading to setting values incorrectly
- fixed a bug that didn't allow removal of the track number
- slightly improved the normalizer, so a "busy" cursor is shown when the connection to the underlying process is lost (the program seems frozen, but it resumes after about 30 seconds)

* Tue Jul 28 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.05.030
- fixed a bug that caused the tag editor to reserve more space than needed even if the "fast save" option was turned off
- fixed a bug that prevented removal of elements from lists
- fixed a bug in the ID3V2 tag writer that prevented "Discard invalid ID3V2 data" and other transformations to properly work with ID3V2.4.0 tags that contain UTF8-encoded strings, resulting in a broken ID3V2.3.0 tag
- file renamer now accepts patterns with no directory separators, in which case the renamed files are placed in the source directory
- pattern dialogs now show the current line and column
- fixed an assertion in the code that determines the file list
- added tooltips for all the notes in the main file table
- improved speed for "Discard invalid ID3V2 data" when no changes are done
- transformation name included in the dialog that shows which file is currently processed
- broken ID3V2 streams get removed when saving from the tag editor
- the tag editor no longer triggers an assertion failure if non-default settings in the file section of the configuration dialog; (e.g. until now saving from the tag editor while original files weren't deleted resulted in this assertion failure)
- fixed a bug in the "Change case for ID3V2 text frames" that resulted in a program crash if some fields were missing from the ID3V2 tag

* Sun Jul 26 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.05.029
- fast save in the tag editor
- file renamer can work with the list of visible files instead of the current album if the user holds CTRL down when pressing the button
- configurable visible transformations
- new transform for keeping a single image, as front cover
- new transform for removing ID3V1
- button to remove image files
- improved paste in tag editor (it is possible to paste to multiple cells or to paste file names copied from file browsers)
- configurable max image size
- tooltips for the transformations menu
- more checks + fixed error reporting in file renamer
- "sessions" button visible by default for second and later sessions
- directory filter no longer shows some directories that don't make sense
- fixed loading images from current dir
- fixed a bug in tag editor patterns that prevented patterns ending with a static text from working
- fixed some bugs in the directory filter

* Sat Jul 18 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.04.026
- non-ASCII file names can now be seen on Windows
- tag editor now looks at filter
- USLT Lyrics inside ID3V2 are now shown
- better alignment for text in note column header on Ubuntu
- size grip on most dialogs
- F1 help
- files changed in the tag editor no longer show up in the main window if a filter is applied and they don't match the filter

* Fri Jul 10 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.03.022
- 2-letter labels
- gradient grouping of notes
- configurable colors
- app no longer crashes when files are changed by external tools
- tooltips are shown for the column headers in the file table
- more consistent font handling

* Sun Jul 05 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.020
- file renamer now replaces invalid characters in file names
- duration is now shown for audio streams
- fixed assertion caused by files with too many streams
- multiple ID3 stream remover no longer included by default in second list
- some changes to the .spec file in the hope it will work on Mandriva

* Sun Jul 05 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.020
- file renamer now replaces invalid characters in file names
- duration is now shown for audio streams
- fixed assertion caused by files with too many streams
- multiple ID3 stream remover no longer included by default in second list
- some changes to the .spec file in the hope it will work on Mandriva

* Wed Jun 24 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.018
- made -mt suffix default for Boost Serialization

* Wed Jun 24 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.017
- always use multithreaded libraries (single-threaded ones may lead to crashes)
- improved assert dialog; now it has more data, which can be copied and even emailed directly
- the tag editor shows a warning in some cases when a user action would result in discarded images

* Sun Jun 21 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.016
- fixed an assertion failure that was triggered by an unsupported text encoding in APIC
- added support for UTF8 text encoding in APIC
- made the documentation look slightly better on IE6

* Sat Jun 20 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.015
- made compilable on Fedora 11 and added Fedora 11 build
- copying missing ID3V1 fields to ID3V2 no longer part of the default custom transformation list 2

* Thu Jun 18 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.014
- the tag editor loads albums much faster than before; this is most visible when navigating to the next / previous album

* Sun Jun 14 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.012
- added support for UTF8 in ID3V240
- added maximize button to most windows in Windows (but could not get this to work with Gnome)
- removed "What's this" button from most windows
- now the main window shows the session name if more than 1 session was defined
- now the main window shows up maximized in Gnome and Windows if it was maximized when it was closed
- changed documentation links to point to new site, at SourceForge
- minor documentation improvements

* Sat Jun 06 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.011
- added missing dependency for SVG icons
- fixed a bug in "Save as ..."

* Thu Jun 04 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.010
- fixed a bug that could cause removal of audio data
- fixed a bug that prevented single-image-saving from working

* Wed Jun 03 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.009
- Ubuntu binaries
- minor UI tweaks

* Mon May 25 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.008
- improved font handling
- minor UI tweaks

* Tue May 19 2009 Marian Ciobanu <ciobi@inbox.com> 0.99.02.007
- initial version
